UniversitySystemMvcApp/Models/Course.cs
using System.ComponentModel.DataAnnotations;

namespace UniversitySystemMvcApp.Models
{
    public class Course
    {
        [Required(ErrorMessage = "Please Enter a Course Name")]
        [StringLength(10, MinimumLength = 5, ErrorMessage = "Enter valid lenght")]
        public string Code { get; set; }
        [Required(ErrorMessage = "Please Select a Department")]
        [Display(Name = "Department")]
        public string DepartmentCode { get; set; }
        [Required(ErrorMessage = "Please Select a Semester")]
        [Display(Name="Semester")]
        public int SemesterId { get; set; }
        [Required(ErrorMessage = "Please Fill the name of the Course")]
        public string Name { get; set; }
        [Required(ErrorMessage = "Specify credit for the course")]
        [Range(1, int.MaxValue, ErrorMessage = "Negative value is not allowed")]
        
        public double Credit { get; set; }
        [Required(ErrorMessage = "Please fill the Description")]
        
        public string Description { get; set; }
        
    }
}

UniversitySystemMvcApp/Controllers/CourseController.cs
using System.Collections.Generic;
using System.Web.Mvc;
using UniversitySystemMvcApp.Manager;
using UniversitySystemMvcApp.Models;
using UniversitySystemMvcApp.Models.ViewModels;

namespace UniversitySystemMvcApp.Controllers
{
    [Authorize]
    public class CourseController : Controller
    {
        public CourseManager CourseManager { get; set; }
        public DepartmentManager DepartmentManager { get; set; }
        public SemesterManager SemesterManager { get; set; }
        public CourseAssignManager CourseAssignManager { get; set; }
        public StudentManager StudentManager { get; set; }
        public EnrollCourseManager EnrollCourseManager { get; set; }

        public CourseController()
        {
            CourseManager = new CourseManager();
            DepartmentManager = new DepartmentManager();
            SemesterManager = new SemesterManager();
            CourseAssignManager = new CourseAssignManager();
            StudentManager = new StudentManager();
            EnrollCourseManager = new EnrollCourseManager();
        }
        [HttpGet]
        public ActionResult SaveCourse()
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            ViewBag.Semesters = SemesterManager.GetAllSemesterForDropDown();
            return View();
        }
        [HttpPost]
        public ActionResult SaveCourse(Course aCourse)
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            ViewBag.Semesters = SemesterManager.GetAllSemesterForDropDown();
            if (ModelState.IsValid)
            {
                ViewBag.Message = CourseManager.Save(aCourse);
            }
            else
            {
                
                ViewBag.Message = "Model State is Invalid";
            }        
            return View();
        }

        [HttpGet]
        public ActionResult ViewCourseStatistics()
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();           
            return View();
        }

        public JsonResult GetCourseViewsByDeptCode(string departmentCode)
        {
            List<CourseStatisticsViewModel> courses =
                CourseAssignManager.GetAllCoursesInfo().FindAll(x => x.DepartmentCode == departmentCode);
            return Json(courses);
        }

        [HttpGet]
        public ActionResult EnrollCourseToStudent()
        {
            ViewBag.StudentsReg = StudentManager.GetAllStudentsForDropdown();
            return View();
        }

        public JsonResult GetStudentByStudentId(int studentId)
        {
            Student student = StudentManager.GetAllStudents().Find(x=>x.Id==studentId);
            return Json(student);
        }
        
        [HttpPost]
        public ActionResult EnrollCourseToStudent(EnrollCourse enrollCourse)
        {
            ViewBag.StudentsReg = StudentManager.GetAllStudentsForDropdown();
            if (ModelState.IsValid)
            {
                ViewBag.Message = EnrollCourseManager.Save(enrollCourse);
            }
            else
            {
                ViewBag.Message = "Model State is Invalid";
            }
            return View();
        }

        [HttpGet]
        public ActionResult UnassignCourses()
        {
            return View();
        }

        [HttpPost]
        public ActionResult UnassignCourses(int? id)
        {
            ViewBag.Message = CourseAssignManager.UnassignCourses();
            return View();
        }
	}
}

UniversitySystemMvcApp/Controllers/StudentController.cs
using System.Collections.Generic;
using System.Web.Mvc;
using UniversitySystemMvcApp.Manager;
using UniversitySystemMvcApp.Models;
using UniversitySystemMvcApp.Models.ViewModels;

namespace UniversitySystemMvcApp.Controllers
{
    [Authorize]
    public class StudentController : Controller
    {
        private DepartmentManager DepartmentManager { get; set; }
        private StudentManager StudentManager { get; set; }
        public CourseManager CourseManager { get; set; }
        private GradeManager GradeManager { get; set; }
        private StudentResultManager StudentResultManager { get; set; }
        public EnrollCourseManager EnrollCourseManager { get; set; }

        public StudentController()
        {
            DepartmentManager = new DepartmentManager();
            StudentManager = new StudentManager();
            GradeManager = new GradeManager();
            CourseManager = new CourseManager();  
            StudentResultManager = new StudentResultManager();
            EnrollCourseManager = new EnrollCourseManager();
        }
       
        [HttpGet]
        public ActionResult SaveStudent()
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            return View();
        }
        [HttpPost]
        public ActionResult SaveStudent(Student student)
        {
            ViewBag.Departments = DepartmentManager.GetAllDepartmentsForDropDown();
            if (ModelState.IsValid)
            {
                ViewBag.Message = StudentManager.Save(student);
                ViewBag.LastStudent = StudentManager.GetStudentByEmail(student.Email);                
            }
            else
            {
                
                ViewBag.Message = "Model State is Invalid";
            }
            return View();
        }
        
        public JsonResult GetCourseCodeByStudentId(int id)
        {
            Student student = StudentManager.GetAllStudents().Find(x => x.Id == id);
            List<Course> courses =
                CourseManager.GetAllCourses().FindAll(x => x.DepartmentCode == student.DepartmentCode);
            return Json(courses);
        }

        

        [HttpGet]
        public ActionResult SaveResult()
        {
            ViewBag.StudentsReg = StudentManager.GetAllStudentsForDropdown();
            ViewBag.Grades = GradeManager.GetAllGradesForDropDown();
            return View();
        }
        [HttpPost]
        public ActionResult SaveResult(StudentResult studentResult)
        {
            ViewBag.StudentsReg = StudentManager.GetAllStudentsForDropdown();
            ViewBag.Grades = GradeManager.GetAllGradesForDropDown();
            if (ModelState.IsValid)
            {
                ViewBag.Message = StudentResultManager.Save(studentResult);
            }
            else
            {
                ViewBag.Message = "Model State is Invalid";
            }
            return View();
        }
        public JsonResult GetCourseRegByStudentId(int studentId)
        {
            List<StudentCourseView> enrolledCourseList = CourseManager.GetCoursesByStudentId(studentId);
            return Json(enrolledCourseList);
        }
        

        [HttpGet]
        public ActionResult ViewStudentResult()
        {
            ViewBag.StudentsReg = StudentManager.GetAllStudentsForDropdown();
            return View();
        }

        public JsonResult GetResultViewByStudentId(int studentId)
        {
            List<StudentResultView> resultViews = StudentResultManager.GetResultsById(studentId);
            return Json(resultViews);
        }

      
	}
}

UniversitySystemMvcApp/Views/Course/EnrollCourseToStudent.cshtml
@model UniversitySystemMvcApp.Models.EnrollCourse
@{
    ViewBag.Title = "EnrollCourseToStudent";
    
}

   
    @using (Html.BeginForm(null, null, FormMethod.Post, new { id = "StudentEnrollForm" }))
    {
        <div style="padding-left: ; border: 0pt whitesmoke groove; border-radius: 5pt; margin-bottom:3% ;">
            <button type="button" class="btn btn-primary btn-lg btn-block" style="margin-top: 3%; margin-bottom: 3%;">Enroll New Course</button>

            <div class="container align-content-center" style="">
                <hr class="bg-white" />
                <div class="form-group">
                    @Html.LabelFor(x => x.StudentId, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.DropDownListFor(x => x.StudentId,
                        new SelectList(ViewBag.StudentsReg, "Value", "Text"), new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                    @Html.ValidationMessageFor(x => x.StudentId, "", new { @class = "text-danger" })
                </div>
                <div class="form-group">
                    @Html.Label("Name", new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextBox("Name", Model, new { @readonly = "readonly", @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                </div>
                <div class="form-group">
                    @Html.Label("Email", new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextBox("Email", Model, new { @readonly = "readonly", @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                </div>
                <div class="form-group">
                    @Html.Label("DepartmentCode", new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextBox("DepartmentCode", Model, new { @readonly = "readonly", @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                </div>
                <div class="form-group">
                    @Html.LabelFor(x => x.CourseCode, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    <select class = "form-control" style = "font-size:large;font-weight:;color:black;background-color: white;" id="CourseCode" name="CourseCode">
                        <option value="">--SELECT--</option>
                    </select>
                    @Html.ValidationMessageFor(x => x.CourseCode, "", new { @class = "text-danger" })
                </div>
                <div class="form-group">
                    @Html.LabelFor(x => x.Date, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextBoxFor(x => x.Date, new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                    @Html.ValidationMessageFor(x => x.Date, "", new { @class = "text-danger" })
                </div>
                
                <button type="submit" class="btn btn-primary">Enroll</button>
                <hr class="bg-white" />
                <div class="form-group">
                    @if (ViewBag.Message != null)
                    {
                        <h5 class="text-success" style="font-weight: bold;font-size: large">@ViewBag.Message</h5>
                    }
                </div>
            </div>
        </div>

    }

<script src="~/Scripts/bootstrap.js"></script>
    <script src="~/Scripts/bootstrap-datepicker.js"></script>
    <script>
    $('#Date').datepicker({
        daysOfWeekDisabled: "5,6",
        daysOfWeekHighlighted: "5,6",
        autoclose: true
    });
    $(document).ready(function() {
        $("#StudentId").change(function() {
            var studentId = $("#StudentId").val();
            $("#CourseCode").empty();
            var json = { studentId: studentId };

            $.ajax({
                type: "POST",
                url: '@Url.Action("GetStudentByStudentId", "Course")',
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(json),
                success: function(data) {
                    //alert(data);

                    var name = data.Name;
                    var email = data.Email;
                    var dept = data.DepartmentCode;
                    $("#Name").val(name);
                    $("#Email").val(email);
                    $("#DepartmentCode").val(dept);
                }
            });
        });
    });
    $(document).ready(function () {

        $("#StudentId").change(function () {
            var studentId = $("#StudentId").val();

            var json = { id: studentId };
            $.ajax({
                type: "POST",
                url: '@Url.Action("GetCourseCodeByStudentId", "Student")',

                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(json),
                success: function (data) {
                    $("#CourseCode").empty();
                    $("#CourseCode").append('<option value="">--SELECT--</option>');
                    $.each(data, function (key, value) {
                        $("#CourseCode").append('<option value=' + value.Code + '>' + value.Name + '</option>');

                    });

                }
            });
        });
    });

    </script>

UniversitySystemMvcApp/Views/Course/SaveCourse.cshtml
@model UniversitySystemMvcApp.Models.Course
@{
    ViewBag.Title = "SaveCourse";

}

<!DOCTYPE html>
<html>
<head>
    <title>Course Save</title>
    
</head>
<body>
    
    @using (Html.BeginForm(null, null, FormMethod.Post, new { id = "CourseSave" }))
    {
        <div style="padding-left: ; border: 0pt whitesmoke groove; border-radius: 5pt; margin-bottom:3% ;">
            <button type="button" class="btn btn-primary btn-lg btn-block" style="margin-top: 3%; margin-bottom: 3%;">Add New Course</button>

            <div class="container align-content-center" style="">
                <hr class="bg-white" />
                <div class="form-group">
                    @Html.LabelFor(x => x.Code, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextBoxFor(x => x.Code, new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                    @Html.ValidationMessageFor(x => x.Code, "", new { @class = "text-danger" })
                </div>
                <div class="form-group">
                    @Html.LabelFor(x => x.Name, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextBoxFor(x => x.Name, new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white" })
                    @Html.ValidationMessageFor(x => x.Name, "", new { @class = "text-danger" })
                </div>

                <div class="form-group">
                    @Html.LabelFor(x => x.Credit, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextBoxFor(x => x.Credit, new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white" })
                    @Html.ValidationMessageFor(x => x.Credit, "", new { @class = "text-danger" })
                </div>
                <div class="form-group">
                    @Html.LabelFor(x => x.Description, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.TextAreaFor(x => x.Description, new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                    @Html.ValidationMessageFor(x => x.Description, "", new { @class = "text-danger" })
                </div>
                <div class="form-group">
                    @Html.LabelFor(x => x.DepartmentCode, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.DropDownListFor(x => x.DepartmentCode,
                        new SelectList(ViewBag.Departments, "Value", "Text"), new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                    @Html.ValidationMessageFor(x => x.DepartmentCode,"",new{ @class = "text-danger" })
                </div>
                <div class="form-group">
                    @Html.LabelFor(x => x.SemesterId, new { @style = "font-size:large;font-weight:bold;color:whitesmoke;" })
                    @Html.DropDownListFor(x => x.SemesterId, new SelectList(ViewBag.Semesters, "Value", "Text"), new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;" })
                    @Html.ValidationMessageFor(x => x.SemesterId, "", new { @class = "text-danger" })
                </div>
                <button type="submit" class="btn btn-primary">Add</button>
                <hr class="bg-white" />
                <div class="form-group">
                    @if (ViewBag.Message != null)
                    {
                        <h5 class="text-success" style="font-weight: bold;font-size: large">@ViewBag.Message</h5>
                    }
                </div>
            </div>
        </div>
    }
    

</body>
</html>

UniversitySystemMvcApp/Views/Course/UnassignCourses.cshtml
@{
    ViewBag.Title = "Un-assignCourses";

}

    @using (Html.BeginForm())
    {
        <div align="center" style="padding-left: ; border: 0pt whitesmoke groove; border-radius: 5pt; margin-bottom:3% ;">
            <button type="button" class="btn btn-primary btn-lg btn-block" style="margin-top: 3%; margin-bottom: 3%;">Un-Assign Courses</button>


            <div class="card text-white bg-dark col-md-6" style="">
                <div class="card-header text-danger">Be-Careful</div>
                <div class="card-body">
                    <h4 class="card-title text-primary">Un-Assign Courses</h4>
                    <p class="card-text">By Clicking The Button All Courses will be Un-Assigned.So, If you want to reset all assigned courses then do this action.</p>
            
                </div>
                <div class="card-footer">
                    <button type="submit" class="btn btn-success btn-outline-dark btn-lg text-white" style="height: " value="Un-Assign Courses" data-confirm="Are you sure to UnAssign All Courses?">Un-Assign All Course</button>
                    @if (ViewBag.Message != null)
                    {
                        <p class="text-success" style="font-size:20px;">@ViewBag.Message</p>
                    }
                </div>
            </div>
        </div>
    }

<
<script>
    $(document).ready(function () {
        jQuery('[data-confirm]').click(function (e) {
            if (!confirm(jQuery(this).attr("data-confirm"))) {
                e.preventDefault();
            }
        });
    });
</script>

UniversitySystemMvcApp/Views/Course/ViewCourseStatistics.cshtml
@model IEnumerable<UniversitySystemMvcApp.Models.ViewModels.CourseStatisticsViewModel>
@{
    ViewBag.Title = "ViewCourseStatistics";

}

@using (Html.BeginForm(null, null, FormMethod.Post, new
{
    id = "ViewCourseStatForm"
}))
{
    <div style="padding-left: ; border: 0pt whitesmoke groove; border-radius: 5pt; margin-bottom:3% ;">
        <button type="button" class="btn btn-primary btn-lg btn-block" style="margin-top: 3%; margin-bottom: 3%;">Course Statistics View</button>
        <div class="form-group" align="center">
            <h4 style="color: whitesmoke;font-weight: bold">Search Courses By Department</h4>
            <br />
            @*@Html.Label("Department", new {@style = "font-size:large;font-weight:bold;color:whitesmoke;"})*@
            @Html.DropDownList("Department", new SelectList(ViewBag.Departments, "Value", "Text", new { id = "Department" }), new { @class = "form-control", @style = "font-size:large;font-weight:;color:black;background-color: white;",@id = "Department" })
        </div>
    </div>
    <br />
    <table id="ViewCourseId" class="table table-hover" style="margin-top: 2%;margin-bottom: 3%">
        <thead>
            <tr class="table-primary">
                <th>Course</th>
                <th>Tittle</th>
                <th>Semester</th>
                <th>Teacher</th>
            </tr>
        </thead>
        <tbody></tbody>
    </table>
}

<script>
    $(document).ready(function () {
        $("#Department").change(function () {
            $('#ViewCourseId tbody').empty();
            var departmentCode = $("#Department").val();
            var json = { departmentCode: departmentCode, };
            $.ajax({
                type: "POST",
                url: '@Url.Action("GetCourseViewsByDeptCode", "Course")',
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(json),
                success: function (data) {
                    $.each(data, function (key, value) {
                        $("#ViewCourseId tbody").append("<tr style='color:azure;background-color:black'><td>" + value.CourseCode + "</td><td>" + value.CourseName + "</td><td>" + value.SemesterName + "</td><td class='text-success' style='font-weight:bold'>" + value.TeacherName + "</td></tr>");
                    });
                }
            });
        });
    });
</script>
<script>
    $(document).ready(function () {
        $('#ViewCourseId').DataTable();
    });
</script>